﻿#!/usr/bin/python
# -*- coding: utf-8 -*-

import IBE
import IBEGui
import codecs
import sys

print("Start app")
# 执行命令：python.exe BatchForServer.py xxxx.txt
# argv[1]是配置文件路径(xxxx.txt)
param = sys.argv[1]
txtParam = '.txt'
if txtParam in param:
    file = open(param, encoding='utf-8')
    line = file.readline()
    # line = line.decode('utf-8','ignore').encode('gbk', 'ignore')
    #print line
    file.close()
else:
    line = param

list = line.split(',')
#print list
ParametersCount = len(list)

if ParametersCount%2 != 0:
    print("wrong number of parameters")
    exit()


App = IBE
Gui = IBEGui

def is_number(s):
    try:  # 如果能运行float(s)语句，返回True（字符串s是浮点数）
        #print("Test is " + s)
        float(s)
        #print("Test is a number")
        return True
    except ValueError:  # ValueError为Python的一种标准异常，表示"传入无效的参数"
        pass  # 如果引发了ValueError这种异常，不做任何事情（pass：不做任何事情，一般用做占位语句）
    try:
        import unicodedata  # 处理ASCii码的包
        unicodedata.numeric(s)  # 把一个表示数字的字符串转换为浮点数返回的函数
        return True
    except (TypeError, ValueError):
        pass
    return False

App.ConfigSet("isHideMainWindow","1")
IBEGui.showMainWindow()

def getAnalysisDomain():
    # "fl" for fluid domain
    # "em" has 3 types: 电流场 "ec", 电场 "ef", 磁场 "mf"
    field = App.ActiveDocument.AnalysisDomain
    print("AnalysisDomain", field)
    return field


try:
    import DefinitionGui
    import PartGui
    import FemGui
    import StructureGui
    import EMFGui
    import ThermalGui
    import FluidGui
    import ResultGui
    import AppDesignerGui
    App.ConfigSet("isAppRunning", "1")
    # 打开文件
    print("Start to open")
    # IBE.open(list[0].decode("gbk").encode("utf-8",'ignore'))
    IBE.open(list[0])
    Gui.getMainWindow().hide()
    # 设置工作目录
    print("Start to set project dir")
    # projDir = list[1].decode("gbk",'ignore').encode("utf-8",'ignore')
    projDir = list[1]
    App.ConfigSet("ProjectDirectory", projDir)
    # 设置参数
    for index in range(ParametersCount):
        if index%2 == 0:
            if index>0:
                print(list[index], list[index+1])
                key = list[index]
                value = list[index+1]
                if key.find('::') == -1:
                    App.ActiveDocument.Parameters.set(key, value)
                else:
                    keylist = key.split('::')
                    if len(keylist) == 2:
                        if is_number(value):
                            print(value + " is a number")
                            Gui.doCommand("App.ActiveDocument." + keylist[0] + "." + keylist[1] + " = " + value)
                        else:
                            print(value + " is not a number")
                            Gui.doCommand("App.ActiveDocument." + keylist[0] + "." + keylist[1] + " = '" + value + "'")

    Gui.setActiveDocument(App.ActiveDocument)
    # 生成几何
    print("Start to redraw model")
    Gui.runCommand("App_RedrawingModel")
    
    field = getAnalysisDomain()
    if field == "em":
        # 显示电路图
        print("Show the Circuit")
        Gui.runCommand("App_ShowCircuitForPython")

    # 网格剖分
    print("Start to redraw mesh")
    Gui.runCommand("App_RedrawingMesh")
    # 计算
    print("Start to compute")
    Gui.runCommand("App_ComputeForPython")
    # 导入结果
    print("Start to import result")
    Gui.runCommand("Result_ViewResult")
    paramFile = projDir + "/params.txt"
    App.ActiveDocument.Parameters.exportFile(paramFile,",")
    # 生成报告
    #print("Start to create report")
    #report = App.ActiveDocument.getObject("Report")
    #if report == None:
    #    report = App.ActiveDocument.addObject("Result::Report", "Report")
    #    App.ActiveDocument.Result.Group += [report]
    #print("Start to generate report")
    #Gui.ActiveDocument.getObject(report.Name).createReport("")
except Exception:
    IBE.Console.PrintError("\n\nThere are some wrong configurations!\n\n")

quit()
